/*
 * This file is generated by jOOQ.
 */
package be.lghs.accounting.model.tables.records;


import be.lghs.accounting.model.enums.SubscriptionType;
import be.lghs.accounting.model.tables.Subscriptions;

import java.time.LocalDate;
import java.util.UUID;

import javax.annotation.processing.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record8;
import org.jooq.Row8;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.14.9",
        "schema version:accounting_0010"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class SubscriptionsRecord extends UpdatableRecordImpl<SubscriptionsRecord> implements Record8<UUID, UUID, UUID, UUID, SubscriptionType, String, LocalDate, LocalDate> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>accounting.subscriptions.id</code>.
     */
    public void setId(UUID value) {
        set(0, value);
    }

    /**
     * Getter for <code>accounting.subscriptions.id</code>.
     */
    public UUID getId() {
        return (UUID) get(0);
    }

    /**
     * Setter for <code>accounting.subscriptions.movement_id</code>.
     */
    public void setMovementId(UUID value) {
        set(1, value);
    }

    /**
     * Getter for <code>accounting.subscriptions.movement_id</code>.
     */
    public UUID getMovementId() {
        return (UUID) get(1);
    }

    /**
     * Setter for <code>accounting.subscriptions.encoder_id</code>.
     */
    public void setEncoderId(UUID value) {
        set(2, value);
    }

    /**
     * Getter for <code>accounting.subscriptions.encoder_id</code>.
     */
    public UUID getEncoderId() {
        return (UUID) get(2);
    }

    /**
     * Setter for <code>accounting.subscriptions.member_id</code>.
     */
    public void setMemberId(UUID value) {
        set(3, value);
    }

    /**
     * Getter for <code>accounting.subscriptions.member_id</code>.
     */
    public UUID getMemberId() {
        return (UUID) get(3);
    }

    /**
     * Setter for <code>accounting.subscriptions.type</code>.
     */
    public void setType(SubscriptionType value) {
        set(4, value);
    }

    /**
     * Getter for <code>accounting.subscriptions.type</code>.
     */
    public SubscriptionType getType() {
        return (SubscriptionType) get(4);
    }

    /**
     * Setter for <code>accounting.subscriptions.comment</code>.
     */
    public void setComment(String value) {
        set(5, value);
    }

    /**
     * Getter for <code>accounting.subscriptions.comment</code>.
     */
    public String getComment() {
        return (String) get(5);
    }

    /**
     * Setter for <code>accounting.subscriptions.start_date</code>.
     */
    public void setStartDate(LocalDate value) {
        set(6, value);
    }

    /**
     * Getter for <code>accounting.subscriptions.start_date</code>.
     */
    public LocalDate getStartDate() {
        return (LocalDate) get(6);
    }

    /**
     * Setter for <code>accounting.subscriptions.end_date</code>.
     */
    public void setEndDate(LocalDate value) {
        set(7, value);
    }

    /**
     * Getter for <code>accounting.subscriptions.end_date</code>.
     */
    public LocalDate getEndDate() {
        return (LocalDate) get(7);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<UUID> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record8 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row8<UUID, UUID, UUID, UUID, SubscriptionType, String, LocalDate, LocalDate> fieldsRow() {
        return (Row8) super.fieldsRow();
    }

    @Override
    public Row8<UUID, UUID, UUID, UUID, SubscriptionType, String, LocalDate, LocalDate> valuesRow() {
        return (Row8) super.valuesRow();
    }

    @Override
    public Field<UUID> field1() {
        return Subscriptions.SUBSCRIPTIONS.ID;
    }

    @Override
    public Field<UUID> field2() {
        return Subscriptions.SUBSCRIPTIONS.MOVEMENT_ID;
    }

    @Override
    public Field<UUID> field3() {
        return Subscriptions.SUBSCRIPTIONS.ENCODER_ID;
    }

    @Override
    public Field<UUID> field4() {
        return Subscriptions.SUBSCRIPTIONS.MEMBER_ID;
    }

    @Override
    public Field<SubscriptionType> field5() {
        return Subscriptions.SUBSCRIPTIONS.TYPE;
    }

    @Override
    public Field<String> field6() {
        return Subscriptions.SUBSCRIPTIONS.COMMENT;
    }

    @Override
    public Field<LocalDate> field7() {
        return Subscriptions.SUBSCRIPTIONS.START_DATE;
    }

    @Override
    public Field<LocalDate> field8() {
        return Subscriptions.SUBSCRIPTIONS.END_DATE;
    }

    @Override
    public UUID component1() {
        return getId();
    }

    @Override
    public UUID component2() {
        return getMovementId();
    }

    @Override
    public UUID component3() {
        return getEncoderId();
    }

    @Override
    public UUID component4() {
        return getMemberId();
    }

    @Override
    public SubscriptionType component5() {
        return getType();
    }

    @Override
    public String component6() {
        return getComment();
    }

    @Override
    public LocalDate component7() {
        return getStartDate();
    }

    @Override
    public LocalDate component8() {
        return getEndDate();
    }

    @Override
    public UUID value1() {
        return getId();
    }

    @Override
    public UUID value2() {
        return getMovementId();
    }

    @Override
    public UUID value3() {
        return getEncoderId();
    }

    @Override
    public UUID value4() {
        return getMemberId();
    }

    @Override
    public SubscriptionType value5() {
        return getType();
    }

    @Override
    public String value6() {
        return getComment();
    }

    @Override
    public LocalDate value7() {
        return getStartDate();
    }

    @Override
    public LocalDate value8() {
        return getEndDate();
    }

    @Override
    public SubscriptionsRecord value1(UUID value) {
        setId(value);
        return this;
    }

    @Override
    public SubscriptionsRecord value2(UUID value) {
        setMovementId(value);
        return this;
    }

    @Override
    public SubscriptionsRecord value3(UUID value) {
        setEncoderId(value);
        return this;
    }

    @Override
    public SubscriptionsRecord value4(UUID value) {
        setMemberId(value);
        return this;
    }

    @Override
    public SubscriptionsRecord value5(SubscriptionType value) {
        setType(value);
        return this;
    }

    @Override
    public SubscriptionsRecord value6(String value) {
        setComment(value);
        return this;
    }

    @Override
    public SubscriptionsRecord value7(LocalDate value) {
        setStartDate(value);
        return this;
    }

    @Override
    public SubscriptionsRecord value8(LocalDate value) {
        setEndDate(value);
        return this;
    }

    @Override
    public SubscriptionsRecord values(UUID value1, UUID value2, UUID value3, UUID value4, SubscriptionType value5, String value6, LocalDate value7, LocalDate value8) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        value7(value7);
        value8(value8);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached SubscriptionsRecord
     */
    public SubscriptionsRecord() {
        super(Subscriptions.SUBSCRIPTIONS);
    }

    /**
     * Create a detached, initialised SubscriptionsRecord
     */
    public SubscriptionsRecord(UUID id, UUID movementId, UUID encoderId, UUID memberId, SubscriptionType type, String comment, LocalDate startDate, LocalDate endDate) {
        super(Subscriptions.SUBSCRIPTIONS);

        setId(id);
        setMovementId(movementId);
        setEncoderId(encoderId);
        setMemberId(memberId);
        setType(type);
        setComment(comment);
        setStartDate(startDate);
        setEndDate(endDate);
    }
}
